package freemind.modes;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;

import javax.swing.ImageIcon;

import freemind.main.Resources;
import freemind.modes.MindMapNode;
import freemind.modes.XMLElementAdapter;
import freemind.modes.mindmapmode.MindMapController;

public class Clones {

	public HashMap items;
	public MindMapController controller;
	
	public Clones(MindMapController controller){
		items = new HashMap();
		this.controller = controller;	
	}
	
	//public Clones(){}
	
	public void addClone(MindMapNode node){
		Clone clone = getClone(node); 
		if(clone != null){
			clone.addNode(node, node.getCloneID());
		} else {
			String cloneID = node.getCloneID();
			if(cloneID == null){
				cloneID = generateCloneID();
			}
			items.put(cloneID, new Clone(controller, node, cloneID));
		}	
	}
	
	public void addClone(MindMapNode sourceNode, MindMapNode targetNode){
		if(hasClone(sourceNode)){
			addClone(sourceNode);
			getClone(sourceNode).addNode(targetNode, sourceNode.getCloneID());
		}else{
			addClone(targetNode);
			getClone(targetNode).addNode(sourceNode, targetNode.getCloneID());
		}
		
	}
	
	public void addClone(MindMapNode node, String cloneID){
		Clone oldClone = getClone(node);
		if(oldClone != null){
			oldClone.deleteNode(node, true);
		}
		Clone newClone = (Clone)items.get(cloneID);
		if(newClone != null){
			newClone.addNode(node, cloneID);
		} else {
			items.put(cloneID, new Clone(controller, node, cloneID));
		}	
	}
	
	public Clone getClone(MindMapNode node){
		return (Clone)items.get(node.getCloneID());
	}
	
	public boolean hasClone(MindMapNode node){
		Clone clone = (Clone)items.get(node.getCloneID()); 
		if(clone != null){
			return true;
		}
		return false;
	}
	
	public void removeEmptyClone(){
		Iterator it = items.values().iterator();
		while(it.hasNext()){
			Clone clone = (Clone)it.next();
			if(clone.hasOnlyOneClone()){
				clone.clear();
			}
			if(clone.isEmpty()){
				items.remove(clone);
			}
		}		
	}
	
	public String generateCloneID(){
		return controller.getModel().getLinkRegistry().generateUniqueCloneID(null, items);
	}
	/*
	public void removeNullClone(){
		Iterator it = items.values().iterator();
		MindMapNode node;
		while(it.hasNext()){
			Clone clone = (Clone)it.next();
			for(int i=0; i<clone.getNodes().size(); i++){
				try{
					node = controller.getNodeFromID(clone.getNode(i));
				}catch(IllegalArgumentException e){node = null;}
				if(node == null){
					clone.getNodes().remove(i);
				}
			}
			
		}		
	}*/
	
	public void removeNullClone(){
		Iterator it = items.values().iterator();
		MindMapNode node;
		while(it.hasNext()){
			Clone clone = (Clone)it.next();
			System.out.println();
			for(int i=0; i<clone.getNodes().size(); i++){
				try{
					node = controller.getNodeFromID(clone.getNode(i));
					System.out.println(node.getCloneID());
					System.out.println(clone.allToString());
				}catch(IllegalArgumentException e){node = null;}
				if(node == null){
					clone.getNodes().remove(i);
				}
			}
			
		}		
	}

}
