/*
 * FreeMind - A Program for creating and viewing Mindmaps Copyright (C)
 * 2000-2004 Joerg Mueller, Daniel Polansky, Christian Foltin and others.
 * 
 * See COPYING for Details
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * Created on 25.08.2004
 */
/* $Id: CopyAction.java,v 1.1.2.1.2.1 2007/07/08 08:37:24 dpolivaev Exp $ */
package freemind.modes.mindmapmode.actions;

import java.awt.datatransfer.Transferable;
import java.awt.event.ActionEvent;
import java.util.Iterator;
import java.util.List;
import javax.swing.AbstractAction;
import javax.swing.ImageIcon;

import freemind.modes.mindmapmode.MindMapController;
import freemind.modes.MindMapNode;
import java.util.*;

public class CopyAction extends AbstractAction {
	private final MindMapController controller;
//	kris 18.09.07
	private ArrayList copyTrees; 
	
	public CopyAction(MindMapController controller) {
		super(controller.getText("copy"), new ImageIcon(controller
				.getResource("images/editcopy.png")));
		this.controller = controller;
		setEnabled(false);
//		kris 18.09.07 
		copyTrees = new ArrayList();    
	}

	public void actionPerformed(ActionEvent e) {
//      kris 22.08.07
    	controller.pasteClone.setEnabled(true);
		if (controller.getMap() != null) {
			Transferable copy = controller.copy();
			if (copy != null) {
				controller.getClipboard().setContents(copy, null);
//				kris 18.09.07
				setCopyTrees();
			}
		}
	}
	
//	kris 14.09.07
	public void loadCopyTree(MindMapNode source, ArrayList copyTree){
	
		copyTree.add(source.getObjectId(controller));
		List children = source.getChildren();
		if(children.size() != 0){
    		for(int i=0; i<children.size(); i++){
    			MindMapNode child = (MindMapNode) children.get(i);
    			if(child.hasChildren()){
    				loadCopyTree(child, copyTree);
    			}else{  
    				copyTree.add(child.getObjectId(controller));
    			}
    		}	
		}
		copyTrees.add(copyTree.clone()); 
		copyTree.clear();
	}
	
	public void loadCopyTrees(){
		
		ArrayList copyTree = new ArrayList(); 
		List selectedNodes = controller.getView().getSelectedNodesSortedByY();
		
		for(Iterator it = selectedNodes.iterator();it.hasNext();) {
            MindMapNode tmpNode =  (MindMapNode)it.next();
            loadCopyTree(tmpNode, copyTree);
		}
	}
	
//	kris 14.09.07
	public void setCopyTrees(){
		clearCopyTrees();
		loadCopyTrees();
	}
	
//	kris 27.08.07
	public ArrayList getCopyTrees(){
		return copyTrees;
	}
	
//	kris 14.09.07
	public void clearCopyTrees(){
    	copyTrees.clear();
	}

}